/*
 * RulePanel.java
 *
 * Created on 24 avril 2009, 15:10
 */

package lotrecscheme;

import java.awt.CardLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.MouseEvent;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import jscheme.JScheme;
import jscheme.SchemePair;

/**
 * this panel graphically represents a rule of the tableau method
 * @author  proprietaire
 */
public class RulePanel extends javax.swing.JPanel {
    private boolean nondeterministrule = false;
    private boolean fail = false;
    final private Scheme scheme;
    private boolean isMerge = false;
    private String mergeSommet1 = null;
    private String mergeSommet2 = null;

    private int dragY = 0;
    private boolean editable = true;

    public boolean isEditable() {
        return editable;
    }

    
    
    
    /** Creates new form RulePanel
     * @param scheme 
     */
    public RulePanel(Scheme scheme) {
        initComponents();
        graphPanelBefore.setPreferredSizeFixed(true);
        graphPanelAfterND1.setPreferredSizeFixed(true);
        graphPanelAfterND2.setPreferredSizeFixed(true);
        graphPanelAfter.setPreferredSizeFixed(true);
        this.scheme = scheme;
        
    }

    /**
     * ne jamais utiliser ce constructeur
     */
    public RulePanel() {initComponents(); this.scheme = null;}
    

    
    public void setEditable(boolean b)
    {
        graphPanelAfter.setEditable(b);
        graphPanelBefore.setEditable(b);
        graphPanelAfterND1.setEditable(b);
        graphPanelAfterND2.setEditable(b);
        panRulePoignee.setVisible(b);
        editable = b;
    }



    private void resize()
    {
        if(isDeterministicRule())
        {
            Dimension d = new Dimension(this.getMinimumSize().width,
                    32+Math.max(graphPanelAfter.getPreferedSize().height, graphPanelBefore.getPreferedSize().height));
            this.setMinimumSize(d);
            this.setPreferredSize(d);
        }
        else
        if(isNonDeterministicRule())
        {
             Dimension d = new Dimension(this.getMinimumSize().width,
                    32+Math.max(graphPanelAfterND1.getPreferedSize().height +
                                graphPanelAfterND2.getPreferedSize().height, graphPanelBefore.getPreferedSize().height));
            this.setMinimumSize(d);
            this.setPreferredSize(d);
        }
        
    }
    private void beforeAfterSynchronize() {
        String s = graphPanelBefore.getSchemeCode();
        if(isNonDeterministicRule())
        {
            graphPanelAfterND1.graphe_remplir(s);
            graphPanelAfterND2.graphe_remplir(s);
            graphPanelAfterND2.graphLayoutCompute();
            graphPanelAfterND2.repaint();
            graphPanelAfterND1.graphLayoutCompute();
            graphPanelAfterND1.repaint();
        }
        else
        if(isDeterministicRule())
        {
            graphPanelAfter.graphe_remplir(s);
            graphPanelAfter.graphLayoutCompute();
            graphPanelAfter.repaint();

            
        }

        resize();
        graphPanelBefore.vertex_positions_inherit(graphPanelAfter);
        graphPanelBefore.repaint();


    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        popupMenuRule = new javax.swing.JPopupMenu();
        mnuTransformHalt = new javax.swing.JMenuItem();
        mnuTransformDeterminist = new javax.swing.JMenuItem();
        mnuTransformNonDeterminist = new javax.swing.JMenuItem();
        mnuTransformNonDeterministPermute = new javax.swing.JMenuItem();
        panMain = new javax.swing.JPanel();
        panRulePoignee = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        panelBefore = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        graphPanelBefore = new lotrecscheme.GraphPanelEditable();
        panSuchThat = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        schemeSuchThat = new lotrecscheme.SchemeEdit();
        jPanel6 = new javax.swing.JPanel();
        panResult = new javax.swing.JPanel();
        panResultDeath = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        panResultND = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        panResultNDActions = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        graphPanelAfterND1 = new lotrecscheme.GraphPanelEditable();
        panPetiteBordure1 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        graphPanelAfterND2 = new lotrecscheme.GraphPanelEditable();
        panResultNormal = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        graphPanelAfter = new lotrecscheme.GraphPanelEditable();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTableLet = new javax.swing.JTable();
        panPetiteBordure = new javax.swing.JPanel();

        popupMenuRule.setName("popupMenuRule"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(lotrecscheme.LispuApp.class).getContext().getResourceMap(RulePanel.class);
        mnuTransformHalt.setText(resourceMap.getString("mnuTransformHalt.text")); // NOI18N
        mnuTransformHalt.setName("mnuTransformHalt"); // NOI18N
        mnuTransformHalt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuTransformHaltActionPerformed(evt);
            }
        });
        popupMenuRule.add(mnuTransformHalt);

        mnuTransformDeterminist.setText(resourceMap.getString("mnuTransformDeterminist.text")); // NOI18N
        mnuTransformDeterminist.setName("mnuTransformDeterminist"); // NOI18N
        mnuTransformDeterminist.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuTransformDeterministActionPerformed(evt);
            }
        });
        popupMenuRule.add(mnuTransformDeterminist);

        mnuTransformNonDeterminist.setText(resourceMap.getString("mnuTransformNonDeterminist.text")); // NOI18N
        mnuTransformNonDeterminist.setName("mnuTransformNonDeterminist"); // NOI18N
        mnuTransformNonDeterminist.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuTransformNonDeterministActionPerformed(evt);
            }
        });
        popupMenuRule.add(mnuTransformNonDeterminist);

        mnuTransformNonDeterministPermute.setText(resourceMap.getString("mnuTransformNonDeterministPermute.text")); // NOI18N
        mnuTransformNonDeterministPermute.setName("mnuTransformNonDeterministPermute"); // NOI18N
        mnuTransformNonDeterministPermute.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuTransformNonDeterministPermuteActionPerformed(evt);
            }
        });
        popupMenuRule.add(mnuTransformNonDeterministPermute);

        setMinimumSize(new java.awt.Dimension(0, 150));
        setName("Form"); // NOI18N
        setPreferredSize(new java.awt.Dimension(222, 150));
        setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.PAGE_AXIS));

        panMain.setName("panMain"); // NOI18N
        panMain.setLayout(new javax.swing.BoxLayout(panMain, javax.swing.BoxLayout.LINE_AXIS));

        panRulePoignee.setMaximumSize(new java.awt.Dimension(24, 32767));
        panRulePoignee.setMinimumSize(new java.awt.Dimension(24, 150));
        panRulePoignee.setName("panRulePoignee"); // NOI18N
        panRulePoignee.setPreferredSize(new java.awt.Dimension(24, 150));
        panRulePoignee.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                panRulePoigneeMousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                panRulePoigneeMouseReleased(evt);
            }
        });
        panRulePoignee.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                panRulePoigneeMouseDragged(evt);
            }
        });
        panRulePoignee.setLayout(new java.awt.BorderLayout());

        jLabel7.setIcon(resourceMap.getIcon("jLabel7.icon")); // NOI18N
        jLabel7.setText(resourceMap.getString("jLabel7.text")); // NOI18N
        jLabel7.setMaximumSize(null);
        jLabel7.setMinimumSize(null);
        jLabel7.setName("jLabel7"); // NOI18N
        jLabel7.setPreferredSize(null);
        jLabel7.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jLabel7MousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jLabel7MouseReleased(evt);
            }
        });
        jLabel7.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                jLabel7MouseDragged(evt);
            }
        });
        panRulePoignee.add(jLabel7, java.awt.BorderLayout.CENTER);

        panMain.add(panRulePoignee);

        panelBefore.setBorder(javax.swing.BorderFactory.createLineBorder(resourceMap.getColor("panelBefore.border.lineColor"), 2)); // NOI18N
        panelBefore.setName("panelBefore"); // NOI18N
        panelBefore.setLayout(new javax.swing.BoxLayout(panelBefore, javax.swing.BoxLayout.Y_AXIS));

        jPanel2.setName("jPanel2"); // NOI18N
        jPanel2.setLayout(new java.awt.BorderLayout());

        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        jScrollPane1.setName("jScrollPane1"); // NOI18N

        graphPanelBefore.setName("graphPanelBefore"); // NOI18N
        graphPanelBefore.setPreferredSize(null);
        graphPanelBefore.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                graphPanelBeforeMouseReleased(evt);
            }
        });

        javax.swing.GroupLayout graphPanelBeforeLayout = new javax.swing.GroupLayout(graphPanelBefore);
        graphPanelBefore.setLayout(graphPanelBeforeLayout);
        graphPanelBeforeLayout.setHorizontalGroup(
            graphPanelBeforeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 88, Short.MAX_VALUE)
        );
        graphPanelBeforeLayout.setVerticalGroup(
            graphPanelBeforeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 25, Short.MAX_VALUE)
        );

        jScrollPane1.setViewportView(graphPanelBefore);

        jPanel2.add(jScrollPane1, java.awt.BorderLayout.PAGE_START);

        panelBefore.add(jPanel2);

        panSuchThat.setName("panSuchThat"); // NOI18N
        panSuchThat.setLayout(new javax.swing.BoxLayout(panSuchThat, javax.swing.BoxLayout.LINE_AXIS));

        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N
        panSuchThat.add(jLabel5);

        schemeSuchThat.setName("schemeSuchThat"); // NOI18N
        schemeSuchThat.setPreferredSize(new java.awt.Dimension(8, 48));
        panSuchThat.add(schemeSuchThat);

        panelBefore.add(panSuchThat);

        panMain.add(panelBefore);

        jPanel6.setName("jPanel6"); // NOI18N
        jPanel6.setLayout(new javax.swing.BoxLayout(jPanel6, javax.swing.BoxLayout.PAGE_AXIS));

        panResult.setMinimumSize(new java.awt.Dimension(128, 150));
        panResult.setName("panResult"); // NOI18N
        panResult.setLayout(new java.awt.CardLayout());

        panResultDeath.setMaximumSize(new java.awt.Dimension(32228, 322222));
        panResultDeath.setName("panResultDeath"); // NOI18N
        panResultDeath.setLayout(new javax.swing.BoxLayout(panResultDeath, javax.swing.BoxLayout.LINE_AXIS));

        jLabel4.setName("jLabel4"); // NOI18N
        panResultDeath.add(jLabel4);

        jLabel6.setIcon(resourceMap.getIcon("jLabel6.icon")); // NOI18N
        jLabel6.setText(resourceMap.getString("jLabel6.text")); // NOI18N
        jLabel6.setComponentPopupMenu(popupMenuRule);
        jLabel6.setName("jLabel6"); // NOI18N
        panResultDeath.add(jLabel6);

        jLabel2.setIcon(resourceMap.getIcon("jLabel2.icon")); // NOI18N
        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N
        panResultDeath.add(jLabel2);

        panResult.add(panResultDeath, "fail");

        panResultND.setMinimumSize(new java.awt.Dimension(68, 150));
        panResultND.setName("panResultND"); // NOI18N
        panResultND.setLayout(new javax.swing.BoxLayout(panResultND, javax.swing.BoxLayout.LINE_AXIS));

        jLabel1.setIcon(resourceMap.getIcon("jLabel1.icon")); // NOI18N
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setComponentPopupMenu(popupMenuRule);
        jLabel1.setName("jLabel1"); // NOI18N
        panResultND.add(jLabel1);

        panResultNDActions.setName("panResultNDActions"); // NOI18N
        panResultNDActions.setLayout(new javax.swing.BoxLayout(panResultNDActions, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel3.setBorder(javax.swing.BorderFactory.createLineBorder(resourceMap.getColor("jPanel3.border.lineColor"), 2)); // NOI18N
        jPanel3.setName("jPanel3"); // NOI18N
        jPanel3.setLayout(new javax.swing.BoxLayout(jPanel3, javax.swing.BoxLayout.LINE_AXIS));

        graphPanelAfterND1.setName("graphPanelAfterND1"); // NOI18N

        javax.swing.GroupLayout graphPanelAfterND1Layout = new javax.swing.GroupLayout(graphPanelAfterND1);
        graphPanelAfterND1.setLayout(graphPanelAfterND1Layout);
        graphPanelAfterND1Layout.setHorizontalGroup(
            graphPanelAfterND1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 360, Short.MAX_VALUE)
        );
        graphPanelAfterND1Layout.setVerticalGroup(
            graphPanelAfterND1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 60, Short.MAX_VALUE)
        );

        jPanel3.add(graphPanelAfterND1);

        panResultNDActions.add(jPanel3);

        panPetiteBordure1.setMaximumSize(new java.awt.Dimension(32767, 4));
        panPetiteBordure1.setMinimumSize(new java.awt.Dimension(0, 4));
        panPetiteBordure1.setName("panPetiteBordure1"); // NOI18N
        panPetiteBordure1.setPreferredSize(new java.awt.Dimension(100, 4));

        javax.swing.GroupLayout panPetiteBordure1Layout = new javax.swing.GroupLayout(panPetiteBordure1);
        panPetiteBordure1.setLayout(panPetiteBordure1Layout);
        panPetiteBordure1Layout.setHorizontalGroup(
            panPetiteBordure1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 364, Short.MAX_VALUE)
        );
        panPetiteBordure1Layout.setVerticalGroup(
            panPetiteBordure1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 4, Short.MAX_VALUE)
        );

        panResultNDActions.add(panPetiteBordure1);

        jPanel4.setBorder(javax.swing.BorderFactory.createLineBorder(resourceMap.getColor("jPanel4.border.lineColor"), 2)); // NOI18N
        jPanel4.setName("jPanel4"); // NOI18N
        jPanel4.setLayout(new javax.swing.BoxLayout(jPanel4, javax.swing.BoxLayout.LINE_AXIS));

        graphPanelAfterND2.setName("graphPanelAfterND2"); // NOI18N

        javax.swing.GroupLayout graphPanelAfterND2Layout = new javax.swing.GroupLayout(graphPanelAfterND2);
        graphPanelAfterND2.setLayout(graphPanelAfterND2Layout);
        graphPanelAfterND2Layout.setHorizontalGroup(
            graphPanelAfterND2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 360, Short.MAX_VALUE)
        );
        graphPanelAfterND2Layout.setVerticalGroup(
            graphPanelAfterND2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 60, Short.MAX_VALUE)
        );

        jPanel4.add(graphPanelAfterND2);

        panResultNDActions.add(jPanel4);

        panResultND.add(panResultNDActions);

        panResult.add(panResultND, "nd");

        panResultNormal.setMinimumSize(new java.awt.Dimension(68, 150));
        panResultNormal.setName("panResultNormal"); // NOI18N
        panResultNormal.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                panResultNormalMouseDragged(evt);
            }
        });
        panResultNormal.setLayout(new javax.swing.BoxLayout(panResultNormal, javax.swing.BoxLayout.X_AXIS));

        jLabel3.setIcon(resourceMap.getIcon("jLabel3.icon")); // NOI18N
        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setComponentPopupMenu(popupMenuRule);
        jLabel3.setName("jLabel3"); // NOI18N
        panResultNormal.add(jLabel3);

        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(resourceMap.getColor("jPanel1.border.lineColor"), 2)); // NOI18N
        jPanel1.setName("jPanel1"); // NOI18N
        jPanel1.setLayout(new java.awt.BorderLayout());

        graphPanelAfter.setAlignmentY(0.0F);
        graphPanelAfter.setName("graphPanelAfter"); // NOI18N
        graphPanelAfter.setPreferredSize(null);
        graphPanelAfter.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                graphPanelAfterMouseReleased(evt);
            }
        });

        javax.swing.GroupLayout graphPanelAfterLayout = new javax.swing.GroupLayout(graphPanelAfter);
        graphPanelAfter.setLayout(graphPanelAfterLayout);
        graphPanelAfterLayout.setHorizontalGroup(
            graphPanelAfterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 360, Short.MAX_VALUE)
        );
        graphPanelAfterLayout.setVerticalGroup(
            graphPanelAfterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 128, Short.MAX_VALUE)
        );

        jPanel1.add(graphPanelAfter, java.awt.BorderLayout.CENTER);

        panResultNormal.add(jPanel1);

        panResult.add(panResultNormal, "d");

        jPanel6.add(panResult);

        jScrollPane3.setName("jScrollPane3"); // NOI18N

        jTableLet.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Variable names", "Values"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jTableLet.setMaximumSize(new java.awt.Dimension(2147483647, 128));
        jTableLet.setMinimumSize(new java.awt.Dimension(150, 128));
        jTableLet.setName("jTableLet"); // NOI18N
        jTableLet.setPreferredSize(new java.awt.Dimension(150, 128));
        jScrollPane3.setViewportView(jTableLet);

        jPanel6.add(jScrollPane3);

        panMain.add(jPanel6);

        add(panMain);

        panPetiteBordure.setMaximumSize(new java.awt.Dimension(32767, 4));
        panPetiteBordure.setMinimumSize(new java.awt.Dimension(0, 8));
        panPetiteBordure.setName("panPetiteBordure"); // NOI18N
        panPetiteBordure.setPreferredSize(new java.awt.Dimension(100, 4));

        javax.swing.GroupLayout panPetiteBordureLayout = new javax.swing.GroupLayout(panPetiteBordure);
        panPetiteBordure.setLayout(panPetiteBordureLayout);
        panPetiteBordureLayout.setHorizontalGroup(
            panPetiteBordureLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 547, Short.MAX_VALUE)
        );
        panPetiteBordureLayout.setVerticalGroup(
            panPetiteBordureLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 7, Short.MAX_VALUE)
        );

        add(panPetiteBordure);
    }// </editor-fold>//GEN-END:initComponents

private void graphPanelBeforeMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_graphPanelBeforeMouseReleased
// TODO add your handling code here:
    beforeAfterSynchronize();
    
}//GEN-LAST:event_graphPanelBeforeMouseReleased

private void graphPanelAfterMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_graphPanelAfterMouseReleased
       beforeAfterSynchronize();
       
}//GEN-LAST:event_graphPanelAfterMouseReleased

private void panResultNormalMouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_panResultNormalMouseDragged
    
}//GEN-LAST:event_panResultNormalMouseDragged


private void dragInit(java.awt.event.MouseEvent evt)
{
    dragY = evt.getY();
}


private void dragLoop(java.awt.event.MouseEvent evt) {
    setLocation(0, getY() + (evt.getY() - dragY));
    Component c = getParent().getComponentAt(new Point(0, getY()-1));

    int i;
    if(c != null) {
        i = getComponentIndexInParent(c);

        if(i < 0)
            return;

        getParent().add(this, i);
        dragDoLayout();
    }
}


private void drop()
{
    dragDoLayout();
}



private void jLabel7MouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel7MouseDragged
    dragLoop(evt);
}//GEN-LAST:event_jLabel7MouseDragged

private void jLabel7MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel7MouseReleased
    checkPopup(evt);
    drop();
}//GEN-LAST:event_jLabel7MouseReleased

private void panRulePoigneeMouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_panRulePoigneeMouseDragged
    dragLoop(evt);
}//GEN-LAST:event_panRulePoigneeMouseDragged

private void panRulePoigneeMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_panRulePoigneeMouseReleased
    drop();
}//GEN-LAST:event_panRulePoigneeMouseReleased

private void panRulePoigneeMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_panRulePoigneeMousePressed

}//GEN-LAST:event_panRulePoigneeMousePressed

private void jLabel7MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel7MousePressed
    checkPopup(evt);
    dragInit(evt);
}//GEN-LAST:event_jLabel7MousePressed

private void mnuTransformHaltActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuTransformHaltActionPerformed
    switchToRuleFail();
}//GEN-LAST:event_mnuTransformHaltActionPerformed

private void mnuTransformDeterministActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuTransformDeterministActionPerformed
    switchToRuleDet();
}//GEN-LAST:event_mnuTransformDeterministActionPerformed

private void mnuTransformNonDeterministActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuTransformNonDeterministActionPerformed
    switchToRuleNotDet();
}//GEN-LAST:event_mnuTransformNonDeterministActionPerformed

private void mnuTransformNonDeterministPermuteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuTransformNonDeterministPermuteActionPerformed
    String schemeCode1 = "(graph " + graphPanelAfterND1.getSchemeCode() + ")";
    graphPanelAfterND1.load("(graph " + graphPanelAfterND2.getSchemeCode() + ")");
    graphPanelAfterND2.load(schemeCode1);
}//GEN-LAST:event_mnuTransformNonDeterministPermuteActionPerformed



private int getComponentIndexInParent(Component c)
{
    for(int i = 0; i < getParent().getComponentCount(); i++)
    {
        if(c == getParent().getComponent(i))
            return i;
    }
    return -1;
}



private void dragDoLayout()
{
    getParent().validate();
     ((JPanel) getParent()).revalidate();
     getParent().doLayout();
     getParent().repaint();
     getParent().getParent().doLayout();
}


    static public boolean isSchemeExpressionRule(Object scheme_expression)
    {
        if(scheme_expression == null)
            return false;
        else
            return scheme_expression.toString().startsWith("(primitiverule (");
    }
    
    
    private void initialize()
    {
        graphPanelAfter.graphe_initialiser();
        graphPanelBefore.graphe_initialiser();
        
        graphPanelAfterND1.graphe_initialiser();
        graphPanelAfterND2.graphe_initialiser();
        
        panSuchThat.setVisible(isEditable());
    }
    
    
    /**
     * load a rule from a scheme_expression that represents the rule
     * @param scheme_expression 
     */
    public void load(Object scheme_expression)
    {
        
        
        
        initialize();
        
        schemeSuchThat.setText("");
        JScheme js = new JScheme();
        System.out.println(scheme_expression);
        if(!scheme_expression.toString().startsWith("("))
        {
            return;
        }
        SchemePair sp = (SchemePair) js.eval("'" + scheme_expression.toString());
        
        loadrec(sp);
        
        recalc();
    }
    
    
    
    
    public void recalc()
    {
        graphPanelBefore.recalc();
        graphPanelAfter.recalc();
        graphPanelAfterND1.recalc();
        graphPanelAfterND2.recalc();
        resize();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private lotrecscheme.GraphPanelEditable graphPanelAfter;
    private lotrecscheme.GraphPanelEditable graphPanelAfterND1;
    private lotrecscheme.GraphPanelEditable graphPanelAfterND2;
    private lotrecscheme.GraphPanelEditable graphPanelBefore;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTable jTableLet;
    private javax.swing.JMenuItem mnuTransformDeterminist;
    private javax.swing.JMenuItem mnuTransformHalt;
    private javax.swing.JMenuItem mnuTransformNonDeterminist;
    private javax.swing.JMenuItem mnuTransformNonDeterministPermute;
    private javax.swing.JPanel panMain;
    private javax.swing.JPanel panPetiteBordure;
    private javax.swing.JPanel panPetiteBordure1;
    private javax.swing.JPanel panResult;
    private javax.swing.JPanel panResultDeath;
    private javax.swing.JPanel panResultND;
    private javax.swing.JPanel panResultNDActions;
    private javax.swing.JPanel panResultNormal;
    private javax.swing.JPanel panRulePoignee;
    private javax.swing.JPanel panSuchThat;
    private javax.swing.JPanel panelBefore;
    private javax.swing.JPopupMenu popupMenuRule;
    private lotrecscheme.SchemeEdit schemeSuchThat;
    // End of variables declaration//GEN-END:variables

    private void loadrec(SchemePair sp) {
        if(sp.isEmpty())
           return;
        
        Object first = sp.first();
        
        if(first instanceof SchemePair)
        {
            SchemePair instruction = (SchemePair) first;
            if(instruction.toString().startsWith("(condition"))
            {
                graphPanelBefore.graphe_remplir((SchemePair) instruction.second());
                graphPanelAfter.graphe_remplir((SchemePair) instruction.second());
                
                graphPanelAfterND1.graphe_remplir((SchemePair) instruction.second());
                graphPanelAfterND2.graphe_remplir((SchemePair) instruction.second());

            //    schemeEditTermsBefore.setText(extractTerms(instruction.second()));
                
            }

            if(instruction.toString().startsWith("(suchthat"))
            {
                 panSuchThat.setVisible(true);
                 schemeSuchThat.setText(((SchemePair) instruction.second()).toString());
                
            }     
            if(instruction.toString().startsWith("(merge "))
            {
                 String sommet1 = (instruction.second()).toString();
                 String sommet2 = (instruction.third()).toString();
                 isMerge = true;
                 mergeSommet1 = sommet1;
                 mergeSommet2 = sommet2;
                 graphPanelAfter.arcextra_ajouter("merge", sommet1, sommet2);
                
            } 
            else if(instruction.toString().startsWith("(let"))
            {
                lettablefill((SchemePair) instruction.second());
            //    schemeEditTermsBefore.setText(extractTerms(instruction.second()));
                
            }
            else if(instruction.toString().startsWith("(add-nondeterminist"))
            {
                graphPanelAfterND1.graphe_remplir((SchemePair) instruction.second());
                graphPanelAfterND2.graphe_remplir((SchemePair) instruction.third());
                
                switchToRuleNotDet();
            }
            else if(instruction.toString().startsWith("(add"))
            {
                if(instruction.second().toString().equals("((halt))"))
                {
                    switchToRuleFail();
                }
                else
                {
                    graphPanelAfter.graphe_remplir((SchemePair) instruction.second());
                    switchToRuleDet();
                }
            }

        }
        
        loadrec((SchemePair) sp.getRest());
        
    }
    
    
    public String getAsetminusB(String A, String B)
//(set-minus '((world A) (formula A p)) '((world A)))
//((formula a p))
    {
            String s = SchemeEdit.scheme_convertir_entextebrut("(set-minus '" + A + " '" + B + ")") ;
            Object o = scheme.eval(s);
            
            if(o == null)
                return "()";
            else
                return o.toString();

    }

    
    
    boolean isNonDeterministicRule()
    {
        return nondeterministrule;
    }
    
    
    boolean isDeterministicRule()
    {
        return !nondeterministrule  & !fail;
    }
    
    
    boolean isFailingRule()
    {
        return fail;    
    }
    
    



    public String getConditions()
    {
       // String listTerms = "";//termsToSchemeCodeWithoutExternalBrackets(schemeEditTermsBefore.getLines());
       // String graphTerms = graphPanelBefore.getSchemeCodeWithoutExternalBracketForConditions();

        
        //return "(" + listTerms + " " + graphTerms + ")";
        return graphPanelBefore.getSchemeCodeForConditions();
    }
    
    
    
    private String getLet()
    {
        String s = "(";
        for(int i = 0; i < jTableLet.getModel().getRowCount(); i++)
        {
            if(jTableLet.getModel().getValueAt(i, 0) == null)
                break;
            s += "(" + jTableLet.getModel().getValueAt(i, 0) + " " +
                       jTableLet.getModel().getValueAt(i, 1) + ")";
            
        }
        s += ")";
        
        return s;
            
    }

    String getSchemeCode()
    {
        String b = getConditions();
        String suchthat_code = null;
        
        if(schemeSuchThat.getText().isEmpty())
        {
            suchthat_code = " ";
        }
        else
        {
            suchthat_code = "(suchthat " + schemeSuchThat.getText() + ")";
        }
        
        if(nondeterministrule)
        {
            return "(primitiverule (condition " + b
                + ") \n " + suchthat_code
                + "\n (add-nondeterminist " + getAsetminusB(graphPanelAfterND1.getSchemeCode(),
                                                            graphPanelBefore.getSchemeCode()) +
                                             getAsetminusB(graphPanelAfterND2.getSchemeCode(),
                                                           graphPanelBefore.getSchemeCode()) + "))";
        }
        
        
        final String merge_code;
        
        if(isMerge)
        {
            merge_code = "(merge " + mergeSommet1 + " " + mergeSommet2 + ")";
        }
        else
        {
            merge_code = "";    
        }
        
        
        final String let_code;
        
        if(getLet().equals("()"))
                let_code = "";
        else
            let_code = "(let " + getLet() + ")\n";
            
        if(fail)
        {
            return "(primitiverule (condition " + b
                    + ") \n " + suchthat_code
                + "\n (add ((halt)) ) )";
        }
        else
            return "(primitiverule (condition " + b
                + ") \n" + suchthat_code + merge_code + let_code +
                 " \n (add " + getAsetminusB(graphPanelAfter.getSchemeCode(),
                                               graphPanelBefore.getSchemeCode()) + "))";
    }



    @Override
    public void setComponentPopupMenu(JPopupMenu popup) {
        super.setComponentPopupMenu(popup);
    }


     private void checkPopup(MouseEvent e) {
        if (e.isPopupTrigger()) {
          super.getComponentPopupMenu().show(this, e.getX(), e.getY());
        }
      }




     private void switchToRuleFail()
     {
        fail = true;
        nondeterministrule = false;
        ((CardLayout) (panResult.getLayout())).show(panResult, "fail");
        jTableLet.setVisible(false);
     }


     private void switchToRuleDet()
     {
        fail = false;
        nondeterministrule = false;
        ((CardLayout) (panResult.getLayout())).show(panResult, "d");
     }

     private void switchToRuleNotDet()
     {
        fail = false;
        nondeterministrule = true;
        ((CardLayout) (panResult.getLayout())).show(panResult, "nd");
     }




/**
 * @return 
 */
     public boolean isOK()
     {
         return schemeSuchThat.isOK();
     }

    private void lettablefill(SchemePair sigma) {
        if(sigma.length() == 0)
        {
            jTableLet.setVisible(false);
        }
        else
        {
            for(int i = 0;  i< sigma.length(); i++)
            {
                final String name = ((SchemePair) sigma.nth(i)).first().toString();
                final String code = ((SchemePair) sigma.nth(i)).second().toString();

                jTableLet.getModel().setValueAt(name, i, 0);
                jTableLet.getModel().setValueAt(code, i, 1);

                jTableLet.setVisible(true);
            }
        }
        
    }
}
